Attribute VB_Name = "modExpression"
Option Explicit

Function Expression(Dat As DATA)
  Expression = SubExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10010 '=
        Expression = Expression = SubExpression(Dat)
      Case 10020 '<>
        Expression = Expression <> SubExpression(Dat)
      Case 10030 '>
        Expression = Expression > SubExpression(Dat)
      Case 10040 '<
        Expression = Expression < SubExpression(Dat)
      Case 10050 '>=
        Expression = Expression >= SubExpression(Dat)
      Case 10060 '<=
        Expression = Expression <= SubExpression(Dat)
      Case 10801 '<end>
        Exit Do
    End Select
  Loop
End Function

Private Function SubExpression(Dat As DATA)
  SubExpression = XorExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10100 '+
        SubExpression = SubExpression + XorExpression(Dat)
      Case 10111 '-
        SubExpression = SubExpression - XorExpression(Dat)
      Case Else
        Dat.InstPointer = Dat.InstPointer - 2
        Exit Do
    End Select
  Loop
End Function

Private Function XorExpression(Dat As DATA)
  XorExpression = OrExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10301
        XorExpression = XorExpression Xor OrExpression(Dat)
      Case Else
        Dat.InstPointer = Dat.InstPointer - 2
        Exit Do
    End Select
  Loop
End Function

Private Function OrExpression(Dat As DATA)
  OrExpression = AndExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10501
        OrExpression = OrExpression Or AndExpression(Dat)
      Case Else
        Dat.InstPointer = Dat.InstPointer - 2
        Exit Do
    End Select
  Loop
End Function

Private Function AndExpression(Dat As DATA)
  AndExpression = TermExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10601
        AndExpression = AndExpression And TermExpression(Dat)
      Case Else
        Dat.InstPointer = Dat.InstPointer - 2
        Exit Do
    End Select
  Loop
End Function

Private Function TermExpression(Dat As DATA)
  TermExpression = OtherExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10701
        TermExpression = TermExpression * OtherExpression(Dat)
      Case 10711
        TermExpression = TermExpression / OtherExpression(Dat)
      Case 10721
        TermExpression = TermExpression \ OtherExpression(Dat)
      Case Else
        Dat.InstPointer = Dat.InstPointer - 2
        Exit Do
    End Select
  Loop
End Function

Private Function OtherExpression(Dat As DATA) As Variant
  OtherExpression = FactorExpression(Dat)
  Do
    Select Case GetNext2(Dat)
      Case 10731
        OtherExpression = OtherExpression * 2 ^ FactorExpression(Dat)
      Case 10741
        OtherExpression = OtherExpression / 2 ^ FactorExpression(Dat)
      Case 10751
        OtherExpression = OtherExpression ^ FactorExpression(Dat)
      Case Else
        Dat.InstPointer = Dat.InstPointer - 2
        Exit Do
    End Select
  Loop
End Function

Private Function FactorExpression(Dat As DATA) As Variant
  Dim Num1 As Double, Num2 As Double

  Select Case GetNext2(Dat)
    Case 15100 'lcase$
      FactorExpression = LCase$(Expression(Dat))
    Case 15110 'ucase$
      FactorExpression = UCase$(Expression(Dat))
    Case 15120 'mid$
      FactorExpression = Mid$(Expression(Dat), Expression(Dat), Expression(Dat))
    Case 15130 'str$
      FactorExpression = CStr(Expression(Dat))
    Case 15140 'val
      FactorExpression = Val(Expression(Dat))
    Case 15150 'hex$
      FactorExpression = Hex$(Expression(Dat))
    Case 15160 'left$
      FactorExpression = Left$(Expression(Dat), Expression(Dat))
    Case 15170 'right$
      FactorExpression = Right$(Expression(Dat), Expression(Dat))
    Case 15180 'asc
      FactorExpression = Asc(Expression(Dat))
    Case 15190 'chr$
      FactorExpression = Chr$(Expression(Dat))
    Case 15200 'true
      FactorExpression = True
    Case 15201 'false
      FactorExpression = False
    Case 15210 'eventid
      FactorExpression = Dat.EventNum
    Case 15220 'message
      FactorExpression = MsgBox(Expression(Dat), Expression(Dat), Expression(Dat))
    Case 15230 'len
      FactorExpression = CLng(Len(CStr(Expression(Dat))))
    Case 15240 'instr
      FactorExpression = InStr(Expression(Dat), Expression(Dat))
    Case 15250 'rnd
      Randomize
      Num1 = Expression(Dat)
      Num2 = Expression(Dat)
      If Num1 > Num2 Then PopError 3
      If Num1 = Num2 Then
        FactorExpression = Num1
      Else
        FactorExpression = (Num2 - Num1 + 1) * Rnd + Num1
      End If
    Case 15260 'rndint
      Randomize
      Num1 = Expression(Dat)
      Num2 = Expression(Dat)
      If Num1 > Num2 Then PopError 3
      If Num1 = Num2 Then
        FactorExpression = Num1
      Else
        FactorExpression = Int((Num2 - Num1 + 1) * Rnd + Num1)
      End If
    Case 15270 'int
      FactorExpression = Int(Expression(Dat))
    Case 17100 '<string>
      FactorExpression = GetString(GetNext2(Dat))
    Case 17200 '<number>
      FactorExpression = GetNext8(Dat)
    Case 17300 '<var>
      FactorExpression = EvalVar(Dat)
    Case 10800 '(
      FactorExpression = Expression(Dat)
    Case 10112 '- (neg)
      FactorExpression = -FactorExpression(Dat)
    Case 10300 'not
      FactorExpression = Not FactorExpression(Dat)
    Case 17610 '<pushed numeric var>
      FactorExpression = GetMem8(Pop(True))
    Case 12720 'call
      FactorExpression = PerformCall(GetNext2(Dat), GetNext2(Dat), Dat)
    Case 12740 'getprop
      FactorExpression = GetObjProp(Frms(GetNext2(Dat)).Objects(GetNext2(Dat)).Obj, GetNext2(Dat))
    Case 12745 'getformprop
      FactorExpression = GetObjProp(Frms(GetNext2(Dat)).Obj, GetNext2(Dat))
    Case 12760 'method
      FactorExpression = ObjMethod(Frms(GetNext2(Dat)).Objects(GetNext2(Dat)).Obj, GetNext2(Dat), Dat)
    Case Else
      PopError 5
  End Select
End Function

Function GetVarAddr(Dat As DATA, Optional Size As Long) As Long
  Dim Displacement As Long

  GetVarAddr = GetNext4(Dat)
  Select Case GetNext2(Dat)
    Case 17310 'loc var
      GetVarAddr = Dat.LocVarInit + GetVarAddr
      Size = GetNext2(Dat)
    Case 17320 'glob var
      Size = GetNext2(Dat)
    Case 17610 '<pushed numeric var>
      GetVarAddr = Pop(True)
      Size = 1
  End Select
  Do
    Select Case GetNext2(Dat)
      Case 17510 'deref
        Size = GetNext2(Dat)
        GetVarAddr = GetMem4(GetVarAddr)
      Case 17520 'array index
        Displacement = Expression(Dat)
        'If Displacement < 0 Or Displacement >= UpperBound(GetVarAddr) Then PopError 1
        GetVarAddr = GetVarAddr + GetNext2(Dat) * Displacement
      Case 17530 'offset
        GetVarAddr = GetVarAddr + GetNext4(Dat)
        Size = GetNext2(Dat)
      Case 17540 'deref only
        GetVarAddr = GetMem4(GetVarAddr)
      Case 17550 'size
        Size = GetNext2(Dat)
      Case 17600 'end
        Exit Function
    End Select
  Loop
End Function

Function EvalVar(Dat As DATA) As Variant
  Dim Size As Long, Addr As Long

  Addr = GetVarAddr(Dat, Size)
  Select Case Size
    Case 0 'str
      EvalVar = GetMemStr(Addr)
    Case 1 'num
      EvalVar = GetMem8(Addr)
    Case 2 'bool
      EvalVar = GetMem1(Addr)
    Case 3 'ptr
      EvalVar = GetMem4(Addr)
    Case 4 'variant
      EvalVar = GetMemVar(Addr)
    Case -1 'deref
      EvalVar = Addr
  End Select
End Function

Sub SetVar(Dat As DATA)
  Dim Size As Long, Addr As Long

  Addr = GetVarAddr(Dat, Size)
  Select Case Size
    Case 0 'str
      PutMemStr Addr, CStr(Expression(Dat))
    Case 1 'num
      PutMem8 Addr, Expression(Dat)
    Case 2 'bool
      PutMem1 Addr, Expression(Dat)
    Case 3 'ptr
      PutMem4 Addr, Expression(Dat)
    Case 4 'variant
      PutMemVar Addr, Expression(Dat)
  End Select
End Sub
