Attribute VB_Name = "modCompile"
Option Explicit
Type OBJINFO
  Code As String
  Nomb As String
  KindOf As Byte
  LocVarSpace As Integer
  Flags As Integer 'bit 0: private
End Type
Type FORMINFO
  Nomb As String
  Objects() As OBJINFO
  MaxObj As Long
End Type
Type PROJECTDATA
  Forms() As FORMINFO
  MaxForm As Long
End Type
Public Palabra() As String
Public Here As String, RuntimeFile As String
Public Project As PROJECTDATA
Public CurForm As Long, CurObj As Long, CurLine As Long
Public Const objflgPrivate = 1

Sub Compile(File As String)
  Dim i As Long, ip As Long, TmpLng As Long, StartCode As Long
  Dim Buff() As Byte

  On Error GoTo HuboErr
  InitializeVariable
  InitializeStrings
  InitializeTipos
  InitializeLabels
  InitializeErrors
  InitializeCtrls
  InitializeFuncs
  frmCompile.Show
  frmCompile.SetLevel 0
  CompileDecls
  CompileFuncs
  frmCompile.SetLevel 1
  With Project
    For CurForm = 0 To .MaxForm - 1
      CompileForm CurForm
    Next
    CurForm = .MaxForm - 1
  End With
  frmCompile.SetLevel 2
  Close
  If FileExists(File) Then Kill File
  FileCopy RuntimeFile, File
  Open File For Binary As 1
  Seek 1, LOF(1) + 1
  StartCode = Seek(1)
  Put 1, , GlobVarAdm(4, "")
  FlushStrings
  LabelAdm 3
  With Project
    Put 1, , .MaxForm
    For i = 0 To .MaxForm - 1
      With .Forms(i)
        Put 1, , .MaxObj
        For ip = 0 To .MaxObj - 1
          With .Objects(ip)
            Put 1, , .KindOf
            Put 1, , CLng(.LocVarSpace)
            Open "form" & i & "_" & .Nomb & ".code" For Binary As 2
            TmpLng = LOF(2)
            Put 1, , TmpLng
            If TmpLng Then
              ReDim Buff(TmpLng - 1)
              Get 2, , Buff
              Put 1, , Buff
            End If
            Close 2
          End With
        Next ip
      End With
    Next i
  End With
  Put 1, , StartCode
  Close
  Limpiar
  Exit Sub
HuboErr:
  If Err.Number <> 1 Then AddError 28, True
  Close
  Limpiar
End Sub

Private Sub CompileForm(ByVal FormId As Long)
  With Project.Forms(FormId)
    For CurObj = 0 To .MaxObj - 1
      frmCompile.Calculate CurObj \ .MaxObj + CurForm, Project.MaxForm
      CompileObj FormId, CurObj
    Next
    CurObj = .MaxObj - 1
  End With
End Sub

Private Sub CompileObj(ByVal FormId As Long, ByVal ObjId As Long)
  Dim CodeArray() As String

  LocVarAdm 2, ""
  With Project.Forms(FormId).Objects(ObjId)
    Select Case .KindOf
      Case kDecl
        Exit Sub
      Case kFunc
        FuncAdm 3, FormId, ObjId
    End Select
    Open "form" & FormId & "_" & .Nomb & ".code" For Binary As 1
    CodeArray = Split(.Code, vbCrLf)
    For CurLine = 0 To UBound(CodeArray)
      CompileLine CodeArray(CurLine)
    Next
    Close 1
    CtrlAdm 4
    .LocVarSpace = LocVarAdm(4, "")
  End With
End Sub

Private Sub CompileLine(CodeLine As String)
  Dim Comienzo As Long, i As Long, TmpLng As Long
  Dim TempVars() As VARINFO
  Dim TmpStr As String

  If GetWords(CodeLine) Then AddError 1, False
  If Len(Palabra(0)) Then CompileLineEx CodeLine
  If Len(CodeLine) Then CompileLine CodeLine
End Sub

Private Sub CompileLineEx(CodeLine As String)
  Dim Comienzo As Long, i As Long, TmpLng As Long
  Dim TempVars() As VARINFO
  Dim TmpStr As String

  Select Case LCase$(Palabra(0))
    Case "param"
      If Project.Forms(CurForm).Objects(CurObj).KindOf <> kFunc Then AddError 3, False
      Exit Sub
    Case "struct"
      AddError 3, False
    Case "end"
      ToFileInt 12100
      Comienzo = 1
    Case "exit"
      ToFileInt 12110
      Comienzo = 1
    Case "var"
      Comienzo = 1
      For i = 0 To CompListaVar(Comienzo, TempVars, tsLocVar) - 1
        With TempVars(i)
          LocVarAdm 0, .Nomb, .Tipo, .Pointer, .HiBound
        End With
      Next i
    Case "redim"
      If LCase$(Palabra(1)) = "preserve" Then
        ToFileInt 12510
        Comienzo = 2
      Else
        ToFileInt 12500
        Comienzo = 1
      End If
      TmpStr = AnalizarTipo(Comienzo, False, TmpLng)
      If TmpLng <> -1 Then AddError 23, False, "Dynamic array"
      ToFileInt GetSize(TmpStr)
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
    Case "show"
      If Len(Palabra(1)) = 0 Then AddError 23, False, "Identifier"
      TmpLng = IsForm(Palabra(1))
      If TmpLng <> -1 Then
        ToFileInt 12300
        ToFileInt TmpLng
        If LCase$(Palabra(2)) = "modal" Then
          ToFileByte 1
          Comienzo = 3
        Else
          ToFileByte 0
          Comienzo = 2
        End If
      Else
        TmpLng = IsObj(CurForm, Palabra(1))
        If TmpLng = -1 Then AddError 5, False, Palabra(1)
        ToFileInt 12310
        ToFileInt TmpLng
        Comienzo = 2
      End If
    Case "hide"
      If Len(Palabra(1)) = 0 Then AddError 23, False, "Identifier"
      TmpLng = IsForm(Palabra(1))
      If TmpLng <> -1 Then
        ToFileInt 12301
      Else
        TmpLng = IsObj(CurForm, Palabra(1))
        If TmpLng = -1 Then AddError 5, False, Palabra(1)
        ToFileInt 12311
      End If
      ToFileInt TmpLng
      Comienzo = 2
    Case "message"
      ToFileInt 12400
      Comienzo = 1
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> "," Then AddError 23, False, "','"
      Comienzo = Comienzo + 1
      Expression Comienzo
    Case "goto"
      If Len(Palabra(1)) = 0 Then AddError 23, False, "Line label"
      TmpLng = LabelAdm(4, , Palabra(1))
      If TmpLng = -1 Then TmpLng = LabelAdm(0, , Palabra(1))
      ToFileInt 12610
      ToFileInt TmpLng
      Comienzo = 2
    Case "return"
      If Project.Forms(CurForm).Objects(CurObj).KindOf <> kFunc Then AddError 3, False
      ToFileInt 12730
      Comienzo = 1
      Expression Comienzo
    Case "if"
      TmpLng = LabelAdm(0)
      i = CtrlAdm(0, eIf)
      Ctrls(i).InfLng1 = TmpLng
      ToFileInt 12600
      Comienzo = 1
      Expression Comienzo
      ToFileInt TmpLng
      If LCase$(Palabra(Comienzo)) <> "then" Then AddError 23, False, "'THEN'"
      Comienzo = Comienzo + 1
      If Len(Palabra(Comienzo)) Then
        While Len(Palabra(Comienzo))
          TmpStr = TmpStr + " " + Palabra(Comienzo) + " "
          Comienzo = Comienzo + 1
        Wend
        CodeLine = TmpStr & ";" & CodeLine & ";;endif"
      End If
    Case "else"
      TmpLng = CtrlAdm(3, eIf)
      If TmpLng = -1 Then AddError 11, False
      With Ctrls(TmpLng)
        .KindOf = eElseIf
        TmpLng = .InfLng1
        .InfLng1 = LabelAdm(0)
        ToFileInt 12610
        ToFileInt .InfLng1
        LabelAdm 1, TmpLng
      End With
      Comienzo = 1
    Case "endif"
      TmpLng = CtrlAdm(3, eIf, eElseIf)
      If TmpLng = -1 Then AddError 10, False
      LabelAdm 1, Ctrls(TmpLng).InfLng1
      CtrlAdm 1
      Comienzo = 1
    Case "do"
      i = CtrlAdm(0, eDo)
      With Ctrls(i)
        .InfLng1 = LabelAdm(2)
        If Len(Palabra(1)) Then
          .InfBool1 = True
          Select Case LCase$(Palabra(1))
            Case "while"
              ToFileInt 12600
            Case "until"
              ToFileInt 12605
            Case Else
              AddError 23, False, "'UNTIL' or 'WHILE'"
          End Select
          Comienzo = 2
          Expression Comienzo
          .InfLng2 = LabelAdm(0)
          ToFileInt .InfLng2
        Else
          Comienzo = 1
        End If
      End With
    Case "loop"
      TmpLng = CtrlAdm(3, eDo)
      If TmpLng = -1 Then AddError 13, False
      With Ctrls(TmpLng)
        If Len(Palabra(1)) Then
          Select Case LCase$(Palabra(1))
            Case "while"
              ToFileInt 12605
            Case "until"
              ToFileInt 12600
            Case Else
              AddError 23, False, "'UNTIL' or 'WHILE'"
          End Select
          If .InfBool1 Then AddError 14, False
          Comienzo = 2
          Expression Comienzo
          ToFileInt .InfLng1
        Else
          Comienzo = 1
          ToFileInt 12610
          ToFileInt .InfLng1
        End If
        If .InfBool1 Then LabelAdm 1, .InfLng2
      End With
      CtrlAdm 1
    Case "for"
      ToFileInt 12700
      Comienzo = 1
      TmpStr = AnalizarTipo(Comienzo, False, TmpLng)
      If TmpLng Then AddError 26, False
      If TmpStr <> "numeric" Then AddError 27, False
      i = CtrlAdm(0, eFor)
      With Ctrls(i)
        ToFileInt 12411 'assign to counter
        ToFileLng 0
        ToFileInt 17610
        ToFileInt 17600
        If Palabra(Comienzo) <> "=" Then AddError 23, False, "'='"
        Comienzo = Comienzo + 1
        Expression Comienzo
        .InfLng1 = LabelAdm(2) 'label2:
        Select Case LCase$(Palabra(Comienzo))
          Case "to"
            .InfBool1 = True
          Case "downto"
          Case Else
            AddError 23, False, "'TO' or 'DOWNTO'"
        End Select
        ToFileInt 12605 'if greater/lower then exit for
        ToFileInt 17300
        ToFileLng 0
        ToFileInt 17610
        ToFileInt 17600
        If .InfBool1 Then ToFileInt 10030 Else ToFileInt 10040
        Comienzo = Comienzo + 1
        Expression Comienzo
        .InfLng2 = LabelAdm(0)
        ToFileInt .InfLng2
      End With
    Case "next"
      TmpLng = CtrlAdm(3, eFor)
      If TmpLng = -1 Then AddError 16, False
      With Ctrls(TmpLng)
        ToFileInt 12411 'incr/decr counter
        ToFileLng 0
        ToFileInt 17610
        ToFileInt 17600
        ToFileInt 17300
        ToFileLng 0
        ToFileInt 17610
        ToFileInt 17600
        If .InfBool1 Then ToFileInt 10100 Else ToFileInt 10111
        ToFileInt 17200
        ToFileDbl 1
        ToFileInt 10801
        ToFileInt 12610 'goto label2
        ToFileInt .InfLng1
        LabelAdm 1, .InfLng2 'label1:
        ToFileInt 12705
      End With
      CtrlAdm 1
      Comienzo = 1
    Case "select"
      Comienzo = 1
      TmpLng = LocVarAdm(5, "", pVariant)
      ToFileInt 12411
      ToFileLng TmpLng
      ToFileInt 17310
      ToFileInt 4 'variant
      ToFileInt 17600
      Expression Comienzo
      i = CtrlAdm(0, eSel)
      With Ctrls(i)
        .InfBool1 = True
        .InfLng1 = LabelAdm(0)
        .InfLng2 = TmpLng
      End With
    Case "case"
      TmpLng = CtrlAdm(3, eSel)
      If TmpLng = -1 Then AddError 18, False
      With Ctrls(TmpLng)
        If Not .InfBool1 Then
          ToFileInt 12610
          ToFileInt .ExitLabel
        End If
        If .InfBool2 Then AddError 3, False
        .InfBool1 = False
        LabelAdm 1, .InfLng1
        If LCase$(Palabra(1)) = "else" Then
          .InfBool2 = True
          Comienzo = 2
        Else
          ToFileInt 12600
          ToFileInt 17300
          ToFileLng .InfLng2
          ToFileInt 17310
          ToFileInt 4 'variant
          ToFileInt 17600
          ToFileInt 10010
          ToFileInt 10800
          Comienzo = 1
          Expression Comienzo
          ToFileInt 10801
          .InfLng1 = LabelAdm(0)
          ToFileInt .InfLng1
        End If
      End With
    Case "endselect"
      TmpLng = CtrlAdm(3, eSel)
      If TmpLng = -1 Then AddError 19, False
      With Ctrls(TmpLng)
        If .InfBool1 Then AddError 33, True
        If Not .InfBool2 Then LabelAdm 1, .InfLng1
      End With
      CtrlAdm 1
      Comienzo = 1
    Case "break"
      Select Case LCase$(Palabra(1))
        Case "do"
          TmpLng = CtrlAdm(2, eDo)
        Case "for"
          TmpLng = CtrlAdm(2, eFor)
        Case "if"
          TmpLng = CtrlAdm(2, eIf, eElseIf)
        Case "select"
          TmpLng = CtrlAdm(2, eSel)
        Case Else
          AddError 0, False
      End Select
      If TmpLng = -1 Then AddError 3, False
      ToFileInt 12610
      ToFileInt Ctrls(TmpLng).ExitLabel
      Comienzo = 2
    Case Else
      If Palabra(1) = ":" Then
        TmpLng = LabelAdm(5, , Palabra(0))
        If TmpLng <> -1 Then AddError 21, False
        TmpLng = LabelAdm(4, , Palabra(0))
        If TmpLng <> -1 Then LabelAdm 1, TmpLng Else LabelAdm 2, , Palabra(0)
        Comienzo = 2
      ElseIf IsVarRef(Palabra(0)) Then
        ToFileInt 12411
        Comienzo = 0
        TmpStr = AnalizarTipo(Comienzo, False, TmpLng)
        If TmpLng Then AddError 26, False
        If Not IsTipoIntrin(TmpStr) Then AddError 9, False
        If Palabra(Comienzo) <> "=" Then AddError 23, False, "'='"
        Comienzo = Comienzo + 1
        Expression Comienzo
      ElseIf MethodAnalyze(Comienzo) Then
      ElseIf FuncAnalyze(Comienzo) Then
      ElseIf PropAnalyze(Comienzo, False) Then
      Else
        AddError 0, False
      End If
  End Select
  If Len(Palabra(Comienzo)) Then AddError 23, False, "End of Statement"
End Sub

Private Sub Limpiar()
  Dim i As Long, ip As Long

  On Error Resume Next
  With Project
    For i = 0 To .MaxForm - 1
      With .Forms(i)
        For ip = 0 To .MaxObj - 1
          Kill "form" & i & "_" & .Objects(ip).Nomb & ".code"
        Next
      End With
    Next
  End With
  Unload frmCompile
End Sub

Function IsForm(Nomb As String) As Long
  Dim i As Long

  With Project
    For i = 0 To .MaxForm - 1
      If LCase$(.Forms(i).Nomb) = LCase$(Nomb) Then
        IsForm = i
        Exit Function
      End If
    Next i
  End With
  IsForm = -1
End Function

Function IsObj(ByVal FormId As Long, Nomb As String, Optional ByVal ThisFormId As Long = -1) As Long
  Dim i As Long

  With Project.Forms(FormId)
    For i = 0 To .MaxObj - 1
      If LCase$(.Objects(i).Nomb) = LCase$(Nomb) Then
        If ThisFormId <> -1 Then If .Objects(i).Flags And objflgPrivate Then If FormId <> ThisFormId Then Exit For
        IsObj = i
        Exit Function
      End If
    Next i
  End With
  IsObj = -1
End Function

Function PropAnalyze(Comienzo As Long, ByVal InExpr As Boolean) As Boolean
  Dim FormId As Long, ObjId As Long, Ret As Long

  FormId = IsForm(Palabra(Comienzo))
  If FormId <> -1 Then
    If Palabra(Comienzo + 1) <> "." Then Exit Function
    ObjId = IsObj(FormId, Palabra(Comienzo + 2), CurForm)
    If ObjId = -1 Then
      ToFileInt 12745
      ToFileInt FormId
      Ret = GetProperty(-1, Palabra(Comienzo + 2), InExpr)
      If Ret = 0 Then AddError 32, False, Palabra(Comienzo + 2)
      ToFileInt Ret
      Comienzo = Comienzo + 3
      If Not InExpr Then
        If Palabra(Comienzo) <> "=" Then AddError 23, False, "'='"
        Comienzo = Comienzo + 1
        Expression Comienzo
      End If
    ElseIf Palabra(Comienzo + 3) = "." Then
      ToFileInt 12740
      ToFileInt FormId
      ToFileInt ObjId
      Ret = GetProperty(Project.Forms(FormId).Objects(ObjId).KindOf, Palabra(Comienzo + 4), InExpr)
      If Ret = 0 Then AddError 32, False, Palabra(Comienzo + 4)
      ToFileInt Ret
      Comienzo = Comienzo + 5
      If Not InExpr Then
        If Palabra(Comienzo) <> "=" Then AddError 23, False, "'='"
        Comienzo = Comienzo + 1
        Expression Comienzo
      End If
    ElseIf Not InExpr Then
      ToFileInt 12750
      ToFileInt FormId
      ToFileInt ObjId
      Comienzo = Comienzo + 3
    Else
      Exit Function
    End If
  Else
    ObjId = IsObj(CurForm, Palabra(Comienzo))
    If ObjId = -1 Then Exit Function
    If Palabra(Comienzo + 1) = "." Then
      ToFileInt 12740
      ToFileInt CurForm
      ToFileInt ObjId
      Ret = GetProperty(Project.Forms(CurForm).Objects(ObjId).KindOf, Palabra(Comienzo + 2), InExpr)
      If Ret = 0 Then AddError 32, False, Palabra(Comienzo + 2)
      ToFileInt Ret
      Comienzo = Comienzo + 3
      If Not InExpr Then
        If Palabra(Comienzo) <> "=" Then AddError 23, False, "'='"
        Comienzo = Comienzo + 1
        Expression Comienzo
      End If
    ElseIf Not InExpr Then
      ToFileInt 12750
      ToFileInt CurForm
      ToFileInt ObjId
      Comienzo = Comienzo + 2
    Else
      Exit Function
    End If
  End If
  PropAnalyze = True
End Function

Function MethodAnalyze(Comienzo As Long) As Boolean
  Dim FormId As Long, ObjId As Long, Ret As Long, Params As Long

  FormId = IsForm(Palabra(Comienzo))
  If FormId <> -1 Then
    If Palabra(Comienzo + 1) <> "." Then Exit Function
    ObjId = IsObj(FormId, Palabra(Comienzo + 2))
    If ObjId = -1 Then Exit Function
    If Palabra(Comienzo + 3) <> "." Then Exit Function
    Ret = GetMethod(Project.Forms(FormId).Objects(ObjId).KindOf, Palabra(Comienzo + 4), Params)
    If Ret = 0 Then Exit Function
    ToFileInt 12760
    ToFileInt FormId
    ToFileInt ObjId
    ToFileInt Ret
    Comienzo = Comienzo + 5
    ParamAnalyze Comienzo, Params
  Else
    ObjId = IsObj(CurForm, Palabra(Comienzo))
    If ObjId = -1 Then Exit Function
    If Palabra(Comienzo + 1) <> "." Then Exit Function
    Ret = GetMethod(Project.Forms(CurForm).Objects(ObjId).KindOf, Palabra(Comienzo + 2), Params)
    If Ret = 0 Then Exit Function
    ToFileInt 12760
    ToFileInt CurForm
    ToFileInt ObjId
    ToFileInt Ret
    Comienzo = Comienzo + 3
    ParamAnalyze Comienzo, Params
  End If
  MethodAnalyze = True
End Function

Private Sub ParamAnalyze(Comienzo As Long, ByVal NumbOfParams As Long)
  If Palabra(Comienzo) = "(" Then
    Comienzo = Comienzo + 1
    If Palabra(Comienzo) = ")" Then
      If NumbOfParams Then AddError 30, False
    Else
      ParamAnalyzeEx Comienzo, NumbOfParams
      If Palabra(Comienzo) <> ")" Then AddError 23, False, "')'"
    End If
    Comienzo = Comienzo + 1
  Else
    If NumbOfParams Then AddError 30, False
  End If
End Sub

Private Sub ParamAnalyzeEx(Comienzo As Long, ByVal NumbOfParams As Long)
  Dim i As Long

  For i = 1 To NumbOfParams
    Expression Comienzo
    If Palabra(Comienzo) <> "," Then
      If i <> NumbOfParams Then AddError 23, False, "','"
      Exit For
    End If
    Comienzo = Comienzo + 1
  Next i
End Sub
