Attribute VB_Name = "modMain"
Option Explicit
Declare Function WaitForSingleObject Lib "kernel32.dll" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (lpApplicationName As Any, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Type PROCESS_INFORMATION
  hProcess As Long
  hThread As Long
  dwProcessId As Long
  dwThreadId As Long
End Type
Type STARTUPINFO
  cb As Long
  lpReserved As String
  lpDesktop As String
  lpTitle As String
  dwX As Long
  dwY As Long
  dwXSize As Long
  dwYSize As Long
  dwXCountChars As Long
  dwYCountChars As Long
  dwFillAttribute As Long
  dwFlags As Long
  wShowWindow As Integer
  cbReserved2 As Integer
  lpReserved2 As Byte
  hStdInput As Long
  hStdOutput As Long
  hStdError As Long
End Type
Public Const VRSNUM = 45556465413.5454@

Sub GetTextBoxData(ByVal hWnd As Long, ByVal Line As Long, LineIndex As Long, LineLen As Long)
  Const EM_LINEINDEX = &HBB, EM_LINELENGTH = &HC1

  LineIndex = SendMessage(hWnd, EM_LINEINDEX, Line, 0)
  LineLen = SendMessage(hWnd, EM_LINELENGTH, LineIndex, 0)
End Sub

Function NoQuotes(Cadena As String) As String
  NoQuotes = Mid$(Left$(Cadena, Len(Cadena) - 1), 2)
End Function

Function GetWords(Cadena As String, Optional StillInfo As Boolean, Optional Maximo As Long) As Boolean
  Dim InputByte As String
  Dim i As Long
  Const Extent = 10, InitSize = 50, Seps = "!?.:@()+-*/\&,=<>[]$^%" + vbTab

  Maximo = 0
  ReDim Palabra(InitSize + Extent)
  For i = 1 To Len(Cadena)
    InputByte = Mid$(Cadena, i, 1)
    If InputByte = vbTab Then InputByte = " "
    If InStr(Seps, InputByte) <> 0 And Not GetWords Then
      If Len(Palabra(Maximo)) Then
        Maximo = Maximo + 1
        If Maximo > InitSize Then ReDim Preserve Palabra(Maximo + Extent)
      End If
      Palabra(Maximo) = Palabra(Maximo) + InputByte
      Maximo = Maximo + 1
      If Maximo > InitSize Then ReDim Preserve Palabra(Maximo + Extent)
    Else
      If Not GetWords Then
        Select Case InputByte
          Case "'"
            Exit For
          Case ";"
            Cadena = Mid$(Cadena, i + 1)
            StillInfo = Len(Cadena)
            Exit For
        End Select
      End If
      If InputByte = """" Then
        If GetWords And i <> Len(Cadena) Then
          If Mid$(Cadena, i + 1, 1) = """" Then
            i = i + 1
            Palabra(Maximo) = Palabra(Maximo) + """"
            GoTo Seguir
          End If
        End If
        GetWords = Not GetWords
      End If
      If InputByte <> " " Or GetWords Then
        Palabra(Maximo) = Palabra(Maximo) + InputByte
      Else
        If Len(Palabra(Maximo)) Then
          Maximo = Maximo + 1
          If Maximo > InitSize Then ReDim Preserve Palabra(Maximo + Extent)
        End If
      End If
    End If
Seguir:
  Next i
  If Not StillInfo Then Cadena = ""
End Function

Sub ToFileLng(ByVal Value As Long)
  Put 1, , Value
End Sub

Sub ToFileInt(ByVal Value As Integer)
  Put 1, , Value
End Sub

Sub ToFileByte(ByVal Value As Byte)
  Put 1, , Value
End Sub

Sub ToFileDbl(ByVal Value As Double)
  Put 1, , Value
End Sub

Function Simplificate(ByVal Cadena As String) As String
  While InStr(Cadena, "\")
    Cadena = Mid$(Cadena, InStr(Cadena, "\") + 1)
  Wend
  Simplificate = Cadena
End Function

Function FileExists(File As String) As Boolean
  On Error GoTo HuboErr
  FileLen File
  FileExists = True
  Exit Function
HuboErr:
End Function

Function CheckVersion() As Boolean
  Dim Size As Long
  Dim Version As Currency

  Size = LOF(1)
  If Size = 0 Then Exit Function
  Get 1, Size - Len(Version) + 1, Version
  CheckVersion = Version = VRSNUM
End Function

Function GetProperty(ByVal KindOf As Long, Nomb As String, ByVal InExpr As Boolean) As Long
  If KindOf = 0 Or KindOf = 8 Then Exit Function
  Select Case LCase$(Nomb)
    Case "x"
      If KindOf <> 7 Then GetProperty = 1
    Case "y"
      If KindOf <> 7 Then GetProperty = 2
    Case "width"
      If KindOf <> 7 Then GetProperty = 3
    Case "height"
      If KindOf <> 7 Then GetProperty = 4
    Case "caption"
      If KindOf = 1 Or KindOf = 2 Or KindOf = 3 Or KindOf = -1 Then GetProperty = 5
    Case "text"
      If KindOf = 5 Or KindOf = 6 Then GetProperty = 6
    Case "enabled"
      If KindOf <> 7 Then GetProperty = 7 Else GetProperty = 12
    Case "visible"
      If KindOf <> 7 Then GetProperty = 8
    Case "listindex"
      If KindOf = 4 Then GetProperty = 9
    Case "listcount"
      If InExpr And KindOf = 4 Then GetProperty = 10
    Case "timer"
      If KindOf = 7 Then GetProperty = 11
    Case "checked"
      If KindOf = 2 Then GetProperty = 13
  End Select
End Function

Function GetMethod(ByVal KindOf As Long, Nomb As String, NumbOfParams As Long) As Long
  If KindOf = 0 Or KindOf = 8 Then Exit Function
  Select Case LCase$(Nomb)
    Case "additem"
      If KindOf = 4 Then
        GetMethod = 1
        NumbOfParams = 1
      End If
    Case "removeitem"
      If KindOf = 4 Then
        GetMethod = 2
        NumbOfParams = 1
      End If
    Case "clear"
      If KindOf = 4 Then
        GetMethod = 3
        NumbOfParams = 0
      End If
    Case "list"
      If KindOf = 4 Then
        GetMethod = 4
        NumbOfParams = 1
      End If
  End Select
End Function

Sub RunExe(File As String)
  Dim StartInfo As STARTUPINFO, ProcessInfo As PROCESS_INFORMATION

  StartInfo.cb = Len(StartInfo)
  StartInfo.wShowWindow = vbNormalFocus
  CreateProcess ByVal 0, File, ByVal 0, ByVal 0, 0, 0, ByVal 0, CurDir$(), StartInfo, ProcessInfo
  WaitForSingleObject ProcessInfo.hProcess, -1
End Sub
