Attribute VB_Name = "modTypes"
Option Explicit
Enum TIPOSCOPE
  tsStruct
  tsGlobVar
  tsLocVar
  tsParam
End Enum
Type COMPINFO
  Nomb As String
  Tipo As String
  Pointer As Boolean
  HiBound As Long
End Type
Type TIPOINFO
  Nomb As String
  Comp() As COMPINFO
  MaxComp As Long
  Size As Long
End Type
Dim Tipos() As TIPOINFO
Dim MaxTipo As Long
Public Const pNumeric = "numeric", pString = "string", pBoolean = "boolean", pVariant = "variant"

Function TipoAdm(ByVal Action As Long, ByVal TipoId As Long, Optional Nomb As String, Optional Tipo As String, Optional Pointer As Boolean, Optional HiBound As Long) As Long
  Dim i As Long

  Select Case Action
    Case 0 'add tipo
      ReDim Preserve Tipos(MaxTipo)
      Tipos(MaxTipo).Nomb = LCase$(Nomb)
      TipoAdm = MaxTipo
      MaxTipo = MaxTipo + 1
    Case 1 'add comp
      With Tipos(TipoId)
        ReDim Preserve .Comp(.MaxComp)
        With .Comp(.MaxComp)
          .Nomb = Nomb
          .Pointer = Pointer
          .HiBound = HiBound
          .Tipo = Tipo
        End With
        .Size = .Size + GetSize(Tipo, Pointer, HiBound)
        .MaxComp = .MaxComp + 1
      End With
    Case 2 'find tipo
      For i = 0 To MaxTipo - 1
        If Tipos(i).Nomb = LCase$(Nomb) Then
          TipoAdm = i
          Exit Function
        End If
      Next i
      TipoAdm = -1
    Case 3 'find comp
      With Tipos(TipoId)
        For i = 0 To .MaxComp - 1
          With .Comp(i)
            If .Nomb = LCase$(Nomb) Then
              Pointer = .Pointer
              Tipo = .Tipo
              HiBound = .HiBound
              Exit Function
            End If
            TipoAdm = TipoAdm + GetSize(.Tipo, .Pointer, .HiBound)
          End With
        Next i
      End With
      TipoAdm = -1
    Case 4 'get size
      TipoAdm = Tipos(TipoId).Size
  End Select
End Function

Function IsIdent(ByVal Scope As TIPOSCOPE, Nomb As String, Optional ByVal Extra As Long) As Boolean
  If Scope = tsStruct Then
    IsIdent = TipoAdm(3, Extra, Nomb) <> -1
  ElseIf Scope = tsGlobVar Then
    IsIdent = GlobVarAdm(1, Nomb) <> -1
  ElseIf Scope = tsLocVar Then
    IsIdent = LocVarAdm(1, Nomb) <> -1
  ElseIf Scope = tsParam Then
    IsIdent = FuncAdm(4, CurForm, CurObj, Nomb) <> -1
  End If
End Function

Function IsTipo(Cadena As String) As Long
  Select Case LCase$(Cadena)
    Case pNumeric, pString, pBoolean, pVariant
      IsTipo = 1
    Case Else
      If TipoAdm(2, 0, Cadena) <> -1 Then IsTipo = 2
  End Select
End Function

Function IsTipoIntrin(Cadena As String) As Boolean
  IsTipoIntrin = IsTipo(Cadena) = 1
End Function

Function GetDataTypeId(Tipo As String, ByVal Pointer As Boolean) As Long
  Dim Ret As Long

  If Pointer Then
    GetDataTypeId = 3
  Else
    Select Case LCase$(Tipo)
      Case pString
        GetDataTypeId = 0
      Case pNumeric
        GetDataTypeId = 1
      Case pBoolean
        GetDataTypeId = 2
      Case pVariant
        GetDataTypeId = 4
      Case Else
        GetDataTypeId = -1
    End Select
  End If
End Function

Function GetSize(Tipo As String, Optional ByVal Pointer As Boolean, Optional ByVal HiBound As Long) As Long
  Dim Ret As Long

  If Pointer Or HiBound = -1 Then
    GetSize = 4
  Else
    Select Case LCase$(Tipo)
      Case pVariant
        GetSize = 16
      Case pNumeric
        GetSize = 8
      Case pString
        GetSize = 4
      Case pBoolean
        GetSize = 1
      Case Else
        Ret = TipoAdm(2, 0, Tipo)
        If Ret <> -1 Then GetSize = TipoAdm(4, Ret)
    End Select
    If HiBound Then GetSize = GetSize * HiBound
  End If
End Function

Function IsValid(ByVal Cadena As String) As Boolean
  Cadena = LCase$(Cadena)
  If Val(Cadena) Then Exit Function
  If InStr(Cadena, """") Then Exit Function
  IsValid = True
End Function

Function AnalizarStruct(Comienzo As Long, TipoSt As String, ByVal InExpr As Boolean) As String
  Dim TmpLng As Long, HiBound As Long
  Dim Tipo As String
  Dim Ptr As Boolean

  AnalizarStruct = TipoSt
  If Palabra(Comienzo) <> "." Then Exit Function
  Comienzo = Comienzo + 1
  TmpLng = TipoAdm(3, TipoAdm(2, 0, TipoSt), Palabra(Comienzo), Tipo, Ptr, HiBound)
  If TmpLng = -1 Then AddError 8, False, Palabra(Comienzo), UCase$(TipoSt)
  AnalizarStruct = Tipo
  ToFileInt 17530
  ToFileLng TmpLng
  ToFileInt GetDataTypeId(Tipo, Ptr) 'GetSize(Tipo, Ptr, HiBound, False)
  Comienzo = Comienzo + 1
  Select Case Palabra(Comienzo)
    Case "@"
      If Not Ptr Then AddError 25, False
      Comienzo = Comienzo + 1
      ToFileInt 17600
      AnalizarStruct = pNumeric
      Exit Function
    Case "%"
      If Not InExpr Then AddError 31, False
      Comienzo = Comienzo + 1
      ToFileInt 17550
      ToFileInt -1
      ToFileInt 17600
      AnalizarStruct = pNumeric
      Exit Function
    Case Else
      If Ptr Then
        ToFileInt 17510
        ToFileInt GetDataTypeId(Tipo, False) 'GetSize(Tipo, , , False)
      End If
  End Select
  If HiBound Then
    If Palabra(Comienzo) = "[" Then
      If HiBound = -1 Then ToFileInt 17540
      ToFileInt 17520
      Comienzo = Comienzo + 1
      Expression Comienzo
      If Palabra(Comienzo) <> "]" Then AddError 23, False, "']'"
      ToFileInt GetSize(Tipo)
      HiBound = 0
      Comienzo = Comienzo + 1
    End If
  End If
  If IsTipo(Tipo) = 2 Then AnalizarStruct = AnalizarStruct(Comienzo, Tipo, InExpr)
End Function

Sub InitializeTipos()
  Erase Tipos
  MaxTipo = 0
End Sub

